<?php
namespace App\Model\History;
use App\Key\K;
use App\Validate\History\Validate;
use EasySwoole\Component\Context\ContextManager;
use EasySwoole\ORM\AbstractModel;

class Base extends AbstractModel{
    protected $connectionName='history';
    protected $errorCode='';
    protected $errorMsg='';
    protected $pk='';
    protected $tableField = [

    ];
    //对应字段的验证关系
    protected $validate = [

    ];

    protected $validateMessage = [

    ];

    protected $operation = [

    ];

    public function getErrorCode(){
        return $this->errorCode;
    }

    protected function setErrorCode($errorCode){
        $this->errorCode=$errorCode;
    }
    protected function setError($error,$errorCode=404){
        $this->errorMsg=$error;
        $this->errorCode=$errorCode;
    }

    public function getError(){
        return $this->errorMsg;
    }
    public function getPageData($arr = [])
    {
        $get = ContextManager::getInstance()->get(K::CONTEXT_CACHE_GET_DATA);
        $page = [];
        if (!isset($arr['field'])) $arr['field'] = ['*'];
        $page['pageNumber'] = $arr['pageNumber'] ?? (intval($get['pageNumber']) > 0 ? intval($get['pageNumber']) : 1);
        $page['pageSize'] = $arr['pageSize'] ?? (intval($get['pageSize']) > 0 ? intval($get['pageSize']) : 10);
        if (!isset($arr['where'])) {
            $arr['where']=$this->createWhere('search');
        }
        //然后对where条件来组合成框架所需要的结构
//        $pk = $this->pk;
//        $hasPk = false;
        $where = [
            'where' => [],
            'else' => [],
        ];
        foreach ($arr['where'] as $v) {
            //这里的$v 的结构是类似tp5的结构，[$key,$condition,$value]
            if (!$v['1']) continue;
            $w = [];
            switch ($v['1']) {
                case 'gt':
                    $w = [$v[2], '>'];
                    break;
                case 'lt':
                    $w = [$v[2], '<'];
                    break;
                case 'elt':
                    $w = [$v[2], '<='];
                    break;
                case 'egt':
                    $w = [$v[2], '>='];
                    break;
                case 'eq':
                case '==':
                    $w = [$v[2], '='];
                    break;
                case 'like':
                    $w = [$v[2], 'like'];
                    break;
            }
            if (!$w) continue;
            if ($where['where'][$v[0]]) {
                //如果已经有了这个条件，由于easyswoole 框架的查询是以key 作为条件的，那么这里我们需要放到else中
                $where['else'][$v[0]] = $w;
            } else {
                $where['where'][$v[0]] = $w;
            }
        }

        $model = $this->where($where['where']);
        if ($where['else']) $model = $model->where($where['else']);
        $page['total'] = $model->count();
        $model = $this->where($where['where']);
        if ($where['else']) $model = $model->where($where['else']);
        $get['order']=json_decode($get['order'],true);
        if (!$arr['order']&&$get['order']){
            $arr['order']=$get['order'];
            if (!$arr['order'][1]||!in_array(strtoupper($arr['order'][1]),['DESC','ASC'])) $arr['order'][1]='DESC';
        }
        if ($arr['order']&&is_array($arr['order'])&&isset($this->tableField[$arr['order'][0]])) {
            $model = $model->order($arr['order'][0],$arr['order'][1]);
        } else {
            if ($this->pk) $model = $model->order($this->pk);
        }
        $page['data'] = $model->field($arr['field'])->limit(($page['pageNumber'] - 1) * $page['pageSize'], $page['pageSize'])->all();
//        $tmp=[];
//        foreach ($page['data'] as $v){
//            $tmp[]=$v->toArray();
//        }
//        $page['data']=$tmp;
        $page['data'] = array_map(function ($v) {
            return $v->toArray();
        }, $page['data']);
//        var_dump($page['data']);
        return $page;
    }

    public function groupAdd($groupName, $data = [])
    {
        //获取当前这个类的所有字段信息
        $groupData = $this->operation[$groupName];
        if (empty($groupData) || empty($groupData['field'])) {
            $this->setError('操作错误!');
            return false;
        }
        if (empty($data)) $data = ContextManager::getInstance()->get(K::CONTEXT_CACHE_POST_DATA);
        $saveData = $this->groupValidate($groupName, $data);
        if (!$saveData) return false;
        $saveData=array_filter($saveData,function ($v){
            return !is_null($v);
        });
        try {
            $add = static::create($saveData);
            $add->save();
            return $add->toArray();
        }catch (\Throwable $throwable){
            $this->setError($throwable->getMessage());
            echo 'base group add error ',$throwable->getMessage(),PHP_EOL;
            return  false;
        }
    }

    public function groupSave($id, $groupName, $data = [])
    {
        if (!$id){
            $this->setError('no data!');
            return false;
        }
        try {
            $modelData = $this->get($id);
        }catch (\Throwable $throwable){
            echo 'get save base error',$throwable->getMessage(),PHP_EOL;
            $this->setError('data error');
            return  false;
        }

        if (empty($modelData)) {
            $this->setError('no data!');
            return false;
        }
        //获取当前这个类的所有字段信息
        $groupData = $this->operation[$groupName];
        if (empty($groupData) || empty($groupData['field'])) {
            $this->setError('no field');
            return false;
        }
        if (empty($data)) $data = ContextManager::getInstance()->get(K::CONTEXT_CACHE_PUT_DATA);
        $saveData = $this->groupValidate($groupName, $data,true);
        if (!$saveData) {
            return false;
        }
        try {
            $saveData=array_filter($saveData,function ($v){
                return !is_null($v);
            });
            $modelData->update($saveData);
            return $modelData->toArray();
        }catch (\Throwable $throwable){
            $this->setError('update error');
            echo 'base update error,',$throwable->getMessage(),PHP_EOL;
            return  false;
        }
    }

    public function createWhere($group)
    {
        //由于之前一直使用TP框架，所以这里的查询的结果都默认返回成了和TP一样的结果 ，然后在模型的查询中来拼接SQL语句
        $get = ContextManager::getInstance()->get(K::CONTEXT_CACHE_GET_DATA);
        $search = $get['search'];
        $search = json_decode($search, true);
        $where = [];
        $group = $this->operation[$group];
        $group = array_intersect_key($this->tableField, array_flip($group['field']));
        foreach ($group as $k => $v) {
            if (!isset($search[$k]) || $search[$k] === '') continue;
            $type=strtolower($v['type']);
            switch ($type) {
                case 'like':
                case 'string':
                    !is_array($search[$k]) ? $where[] = [$k, 'like', '%' . $search[$k] . '%'] : true;
                    break;
                case 'timestamp':
                    $startTime = date('Y-m-d H:i:s', $search[$k][0]);
                    $endTime = date('Y-m-d H:i:s', $search[$k][1]);
                    if ($startTime && $endTime) {
                        $where[] = [$k, 'egt', $search[$k][0]];
                        $where[] = [$k, 'elt', $search[$k][1]];
                    }
                    break;
                case 'time_str':
                    if (strtotime($search[$k][0]) && strtotime($search[$k][1])) {
                        $where[] = [$k, 'egt', $search[$k][0]];
                        $where[] = [$k, 'elt', $search[$k][1]];
                    }
                    break;
                case 'date_int':
                    $startTime = strtotime($search[$k][0]);
                    $endTime = strtotime($search[$k][1]);
                    if ($startTime && $endTime) {
                        $where[] = [$k, 'egt', find_time_start_end($startTime, 'day', 'start')];
                        $where[] = [$k, 'elt', find_time_start_end($endTime, 'day', 'end')];
                    }
                    break;
                default:
                    !is_array($search[$k]) ? $where[] = [$k, 'eq', $search[$k]] : true;
            }
        }
        return $where;
    }

    public function groupValidate($groupName, $data,$isSave='')
    {
        //获取当前这个组的字段信息
        $groupData = $this->operation[$groupName];
        if ($groupData['field']==='*'){
            $rule = $this->validate;
        }else{
            $rule = array_intersect_key($this->validate, array_flip($groupData['field']));
        }
        if (!$rule){
            if ($groupData['field']==='*'){
                return $data;
            }else{
                return array_intersect_key($data, array_flip($groupData['field']));
            }
        }
        if ($isSave===true){
            //如果是在更新操作，只会检查提交上来的数据
            foreach ($rule as $k=>$v){
                if (!isset($data[$k])) unset($rule[$k]);
            }
        }
        $validate = new Validate();
        $validate->rule($rule);
        $validate->message($this->validateMessage);
        if (!$validate->check($data)) {
            $this->setError($validate->getError());
            $this->setErrorCode($validate->getError());
            return false;
        }
        //返回允许更新的字段信息
        if ($groupData['field']==='*'){
            return  $data;
        }
        return array_intersect_key($data, array_flip($groupData['field']));
    }

    protected function jsonToArray($str){
        return json_decode($str,true)??[];
    }

    protected function arrayToJson($arr){
        return json_encode($arr,JSON_UNESCAPED_UNICODE)??'[]';
    }
}
